// Read Sensors
int Read_Ping_Sensor() {
  int cm=0;
  //trigger the sensor
  unsigned long value = 0;
  pinMode(PingPin, OUTPUT);
  digitalWrite(PingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(PingPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(PingPin, LOW);
  //receive the echo
  pinMode(PingPin, INPUT);
  digitalWrite(PingPin, HIGH); // turn on pull up resistor
  value = pulseIn(PingPin, HIGH);
  value=value/58.138;
  cm=int(value);
  return cm;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Read_Sharp_Sensor(byte model, byte pin) {
  int value = 0;
  value = analogRead(pin);
  //if (value<70)value=70;
  switch (model) {
    case SR:
      return (2914/(value+5))-1; // for GP2D120 (4-30cm)
      break;
    case MR:
      return 1384.4*pow(value,-.9988); // for GP2D12 (10-80cm)
      break;
    case LR:  
      return 1904.5*pow(value,-.89); // for GP2Y0A02YK (20-150cm)
      //return 7715.1*pow(value,-.8767); // for GP2Y0A02YK (15-150cm)
      break;
  }
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Read_Thermopile_Array(){
  for(byte i = 0; i < 9; i++){              // Loops and stores temperature data in array
    temperature[i] = I2C_read(Thermo, i+1); // address, register
  }
}

int I2C_read(int addr, int reg){    // Function to receive one byte of data from slave
  Wire.beginTransmission(addr);       // Begin communication with slave
  Wire.send(reg);                     // Send register to slave
  Wire.endTransmission();
  Wire.requestFrom(addr, 1);          // Request 1 byte
  while(Wire.available() < 1);        // Wait for byte to arrive
  int data = Wire.receive();          // Get byte
  return(data);                       // return byte
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Read_Compass_Sensor(){
  // Send a "A" command to the HMC6352
  // This requests the current heading data
  Wire.beginTransmission(0x21);
  Wire.send(0x41);              // The "Get Data" command
  Wire.endTransmission();
  delay(7);                   // The HMC6352 needs at least a 70us (microsecond) delay
  // after this command.  Using 7ms just makes it safe
  // Read the 2 heading bytes, MSB first
  // The resulting 16bit word is the compass heading in 10th's of a degree
  // For example: a heading of 1345 would be 134.5 degrees
  Wire.beginTransmission(0x21);
  Wire.requestFrom(0x21, 2);        // Request the 2 byte heading (MSB comes first)
  j = 0;
  while(Wire.available())
  {
    char c = Wire.receive();
    headingData[j] = c;
    j++;
  }
  Wire.endTransmission();
  Serial.print("Heading = ");
  frac = headingData[0]*256 + headingData[1];
  deg = frac / 10;
  frac = frac - deg * 10;
  Serial.print(deg);
  Serial.print(".");
  Serial.println(frac);
}

